Index: XIOS3/trunk/src/node/domain.cpp
===================================================================
--- XIOS3/trunk/src/node/domain.cpp	(revision 2498)
+++ XIOS3/trunk/src/node/domain.cpp	(revision 2507)
@@ -293,4 +293,5 @@
     \param [in] nbLocalDomain number of local domain on the domain destination
    */
+
    void CDomain::redistribute(int nbLocalDomain)
    TRY
@@ -862,5 +863,5 @@
         
 
-        if (!area.isEmpty()) area.transposeSelf(1, 0); // => to be checked why is it transposed
+//        if (!area.isEmpty()) area.transposeSelf(1, 0); // => to be checked why is it transposed
      }
 
@@ -914,4 +915,37 @@
    CATCH_DUMP_ATTR
 
+   void CDomain::compute2dBox(void)
+   {
+     if (i_index.numElements()==0)
+     {
+       ibeginValue_= 0 ;
+       jbeginValue_= 0 ;
+       niValue_= 0 ;
+       njValue_= 0 ;
+     }
+     else
+     {
+       int maxI=0 ;
+       int maxJ=0 ;
+       int minI=nj_glo*ni_glo ;
+       int minJ=nj_glo*ni_glo ;
+       int i,j,k,ij ;
+       for(int k=0; k<i_index.numElements(); k++)
+       {
+         ij=j_index(k)*ni_glo + i_index(k) ;
+         i=ij%ni_glo ;
+         j=ij/ni_glo ;
+         if (i<minI) minI=i;
+         if (j<minJ) minJ=j;
+         if (i>maxI) maxI=i;
+         if (j>maxJ) maxJ=j;
+       }
+       ibeginValue_=minI ;
+       jbeginValue_=minJ ;
+       niValue_=maxI-minI+1 ;
+       njValue_=maxJ-minJ+1 ;
+     }
+   }
+
    size_t CDomain::getGlobalWrittenSize(void)
    {
@@ -943,5 +977,5 @@
         {          
          // No information about ni
-          int minIndex = ni_glo - 1;
+          int minIndex = ni_glo*nj_glo - 1;
           int maxIndex = 0;
           for (int idx = 0; idx < i_index.numElements(); ++idx)
@@ -950,12 +984,11 @@
             if (i_index(idx) > maxIndex) maxIndex = i_index(idx);
           }
-	  if (i_index.numElements()) {
+	        if (i_index.numElements())
+          {
             ni = maxIndex - minIndex + 1; 
             minIIndex = minIndex;
           }	    
-	  else {
-            ni = 0;
-	  }
-        }
+	        else ni = 0;
+	      }
 
         // It's not so correct but if ibegin is not the first value of i_index 
@@ -1010,5 +1043,5 @@
         {
           // No information about nj
-          int minIndex = nj_glo - 1;
+          int minIndex = ni_glo*nj_glo - 1;
           int maxIndex = 0;
           for (int idx = 0; idx < j_index.numElements(); ++idx)
@@ -1354,4 +1387,123 @@
      }
      else if (!lonvalue_1d.isEmpty()  && !lonlatValueExisted)
+     {
+       if (type_attr::rectilinear == type)
+       {
+         if (ni == lonvalue_1d.numElements() && nj == latvalue_1d.numElements())
+         {
+           lonvalue.resize(ni * nj);
+           latvalue.resize(ni * nj);
+           if (hasBounds)
+           {
+             bounds_lonvalue.resize(nvertex, ni * nj);
+             bounds_latvalue.resize(nvertex, ni * nj);
+           }
+
+           for (int j = 0; j < nj; ++j)
+           {
+             for (int i = 0; i < ni; ++i)
+             {
+               int k = j * ni + i;
+
+               lonvalue(k) = lonvalue_1d(i);
+               latvalue(k) = latvalue_1d(j);
+
+               if (hasBounds)
+               {
+                 for (int n = 0; n < nvertex; ++n)
+                 {
+                   bounds_lonvalue(n,k) = bounds_lon_1d(n,i);
+                   bounds_latvalue(n,k) = bounds_lat_1d(n,j);
+                 }
+               }
+             }
+           }
+         }
+         else if (i_index.numElements() == lonvalue_1d.numElements() && j_index.numElements() == latvalue_1d.numElements()  && !lonlatValueExisted)
+         {
+           lonvalue.reference(lonvalue_1d.copy());
+           latvalue.reference(latvalue_1d.copy());
+           if (hasBounds)
+           {
+             bounds_lonvalue.reference(bounds_lon_1d.copy());
+             bounds_latvalue.reference(bounds_lat_1d.copy());
+           }
+         }
+         else
+           ERROR("CDomain::completeLonClient(void)",
+                 << "[ id = " << this->getId() << " , context = '" << CObjectFactory::GetCurrentContextId() << " ] "
+                 << "'lonvalue_1d' and 'latvalue_1d' does not have the same size as the local domain." << std::endl
+                 << "'lonvalue_1d' size is " << lonvalue_1d.numElements() 
+                 << " and 'latvalue_1d' size is " << latvalue_1d.numElements() << std::endl 
+                 << " They should be correspondingly " << ni.getValue() << " and "  << nj.getValue() << " or " << std::endl
+                 << i_index.numElements() << " and "  << j_index.numElements() << ".");
+       }
+       else if (type == type_attr::curvilinear || type == type_attr::unstructured  && !lonlatValueExisted)
+       {
+         lonvalue.reference(lonvalue_1d.copy());
+         latvalue.reference(latvalue_1d.copy());
+         if (hasBounds)
+         {
+           bounds_lonvalue.reference(bounds_lon_1d.copy());
+           bounds_latvalue.reference(bounds_lat_1d.copy());
+         }
+       }
+     }
+
+     if (!area_2d.isEmpty() && areavalue.isEmpty())
+     {
+       areavalue.resize(ni*nj);
+       for (int j = 0; j < nj; ++j)
+       {
+         for (int i = 0; i < ni; ++i)
+         {
+           int k = j * ni + i;
+           areavalue(k) = area_2d(i,j);
+         }
+       }
+     }
+     else if (!area_1d.isEmpty() && areavalue.isEmpty()) areavalue.reference(area_1d.copy());
+
+   }
+   CATCH_DUMP_ATTR
+
+   /*
+     Convert internal longitude latitude value used by XIOS to "lonvalue_*" which can be retrieved with Fortran interface
+   */
+   void CDomain::convertLonLatValue(void)
+   TRY
+   {
+     bool lonlatValueExisted = (0 != lonvalue.numElements()) || (0 != latvalue.numElements());
+     if (!lonvalue_2d.isEmpty() && lonlatValueExisted)
+     {
+       lonvalue_2d.resize(ni,nj);
+       latvalue_2d.resize(ni,nj);
+       if (hasBounds)
+       {
+         bounds_lon_2d.resize(nvertex, ni, nj);
+         bounds_lat_2d.resize(nvertex, ni, nj);
+       }
+
+       for (int j = 0; j < nj; ++j)
+       {
+         for (int i = 0; i < ni; ++i)
+         {
+           int k = j * ni + i;
+
+           lonvalue_2d(i,j) = lonvalue(k);
+           latvalue_2d(i,j) = latvalue(k);
+
+           if (hasBounds)
+           {
+             for (int n = 0; n < nvertex; ++n)
+             {
+               bounds_lon_2d(n,i,j) = bounds_lonvalue(n,k);
+               bounds_lat_2d(n,i,j) = bounds_latvalue(n,k);
+             }
+           }
+         }
+       }
+     }
+     else if (!lonvalue_1d.isEmpty()  && lonlatValueExisted)
      {
        if (type_attr::rectilinear == type)
@@ -1417,121 +1569,4 @@
        }
      }
-
-     if (!area.isEmpty() && areavalue.isEmpty())
-     {
-        areavalue.resize(ni*nj);
-       for (int j = 0; j < nj; ++j)
-       {
-         for (int i = 0; i < ni; ++i)
-         {
-           int k = j * ni + i;
-           areavalue(k) = area(i,j);
-         }
-       }
-     }
-   }
-   CATCH_DUMP_ATTR
-
-   /*
-     Convert internal longitude latitude value used by XIOS to "lonvalue_*" which can be retrieved with Fortran interface
-   */
-   void CDomain::convertLonLatValue(void)
-   TRY
-   {
-     bool lonlatValueExisted = (0 != lonvalue.numElements()) || (0 != latvalue.numElements());
-     if (!lonvalue_2d.isEmpty() && lonlatValueExisted)
-     {
-       lonvalue_2d.resize(ni,nj);
-       latvalue_2d.resize(ni,nj);
-       if (hasBounds)
-       {
-         bounds_lon_2d.resize(nvertex, ni, nj);
-         bounds_lat_2d.resize(nvertex, ni, nj);
-       }
-
-       for (int j = 0; j < nj; ++j)
-       {
-         for (int i = 0; i < ni; ++i)
-         {
-           int k = j * ni + i;
-
-           lonvalue_2d(i,j) = lonvalue(k);
-           latvalue_2d(i,j) = latvalue(k);
-
-           if (hasBounds)
-           {
-             for (int n = 0; n < nvertex; ++n)
-             {
-               bounds_lon_2d(n,i,j) = bounds_lonvalue(n,k);
-               bounds_lat_2d(n,i,j) = bounds_latvalue(n,k);
-             }
-           }
-         }
-       }
-     }
-     else if (!lonvalue_1d.isEmpty()  && lonlatValueExisted)
-     {
-       if (type_attr::rectilinear == type)
-       {
-         if (ni == lonvalue_1d.numElements() && nj == latvalue_1d.numElements())
-         {
-           lonvalue.resize(ni * nj);
-           latvalue.resize(ni * nj);
-           if (hasBounds)
-           {
-             bounds_lonvalue.resize(nvertex, ni * nj);
-             bounds_latvalue.resize(nvertex, ni * nj);
-           }
-
-           for (int j = 0; j < nj; ++j)
-           {
-             for (int i = 0; i < ni; ++i)
-             {
-               int k = j * ni + i;
-
-               lonvalue(k) = lonvalue_1d(i);
-               latvalue(k) = latvalue_1d(j);
-
-               if (hasBounds)
-               {
-                 for (int n = 0; n < nvertex; ++n)
-                 {
-                   bounds_lonvalue(n,k) = bounds_lon_1d(n,i);
-                   bounds_latvalue(n,k) = bounds_lat_1d(n,j);
-                 }
-               }
-             }
-           }
-         }
-         else if (i_index.numElements() == lonvalue_1d.numElements() && j_index.numElements() == latvalue_1d.numElements()  && !lonlatValueExisted)
-         {
-           lonvalue.reference(lonvalue_1d);
-           latvalue.reference(latvalue_1d);
-            if (hasBounds)
-           {
-             bounds_lonvalue.reference(bounds_lon_1d);
-             bounds_latvalue.reference(bounds_lat_1d);
-           }
-         }
-         else
-           ERROR("CDomain::completeLonClient(void)",
-                 << "[ id = " << this->getId() << " , context = '" << CObjectFactory::GetCurrentContextId() << " ] "
-                 << "'lonvalue_1d' and 'latvalue_1d' does not have the same size as the local domain." << std::endl
-                 << "'lonvalue_1d' size is " << lonvalue_1d.numElements() 
-                 << " and 'latvalue_1d' size is " << latvalue_1d.numElements() << std::endl 
-                 << " They should be correspondingly " << ni.getValue() << " and "  << nj.getValue() << " or " << std::endl
-                 << i_index.numElements() << " and "  << j_index.numElements() << ".");
-       }
-       else if (type == type_attr::curvilinear || type == type_attr::unstructured  && !lonlatValueExisted)
-       {
-         lonvalue.reference(lonvalue_1d);
-         latvalue.reference(latvalue_1d);
-         if (hasBounds)
-         {
-           bounds_lonvalue.reference(bounds_lon_1d);
-           bounds_latvalue.reference(bounds_lat_1d);
-         }
-       }
-     }
    }
    CATCH_DUMP_ATTR
@@ -1636,8 +1671,8 @@
    {
      bool hasAreaValue = (!areavalue.isEmpty() && 0 != areavalue.numElements());
-     hasArea = !area.isEmpty();
+     hasArea = !area_1d.isEmpty() || !area_2d.isEmpty();
      if (hasArea && !hasAreaValue)
      {
-       if (area.extent(0) != ni || area.extent(1) != nj)
+       if (!area_2d.isEmpty() && (area_2d.extent(0) != ni || area_2d.extent(1) != nj))
        {
          ERROR("CDomain::checkArea(void)",
@@ -1645,18 +1680,16 @@
                << "The area does not have the same size as the local domain." << std::endl
                << "Local size is " << ni.getValue() << " x " << nj.getValue() << "." << std::endl
-               << "Area size is " << area.extent(0) << " x " << area.extent(1) << ".");
-       }
-//       if (areavalue.isEmpty())
-//       {
-//          areavalue.resize(ni*nj);
-//         for (int j = 0; j < nj; ++j)
-//         {
-//           for (int i = 0; i < ni; ++i)
-//           {
-//             int k = j * ni + i;
-//             areavalue(k) = area(i,j);
-//           }
-//         }
-//       }
+               << "Area size is " << area_2d.extent(0) << " x " << area_2d.extent(1) << ".");
+       }
+       
+       if (!area_1d.isEmpty() && area_1d.extent(0) != ni*nj)
+       {
+         ERROR("CDomain::checkArea(void)",
+               << "[ id = " << this->getId() << " , context = '" << CObjectFactory::GetCurrentContextId() << " ] "
+               << "The area does not have the same size as the local domain." << std::endl
+               << "Local size is " << ni.getValue() << " x " << nj.getValue() << "." << std::endl
+               << "Area size is " << area_1d.extent(0) << " but must be ni*nj=" << ni*nj << " .");
+       }
+
      }
    }
@@ -1731,4 +1764,5 @@
       if (this->checkAttributes_done_) return;
       this->checkDomain();
+      this->compute2dBox() ;
       this->checkLonLat();
       this->checkBounds();
@@ -1803,5 +1837,5 @@
      excludedAttr.insert(excludedAttr.end(), { "mask_1d", "mask_2d" }); // ???
      excludedAttr.insert(excludedAttr.end(), { "bounds_lon_1d", "bounds_lat_1d", "bounds_lon_2d", "bounds_lat_2d" });
-     excludedAttr.insert(excludedAttr.end(), { "area" });
+     excludedAttr.insert(excludedAttr.end(), { "area_1d", "area_2d" });
      // private
      excludedAttr.insert(excludedAttr.end(), { "lon_start", "lon_end", "lat_start", "lat_end" });
@@ -1952,39 +1986,5 @@
     CContext* context = CContext::getCurrent();
     map<int, CArray<size_t,1>> globalIndex ;
-/* old method
-    if (type==EDistributionType::BANDS) // Bands distribution to send to file server
-    {
-      int nbServer = client->getRemoteSize();
-      std::vector<int> nGlobDomain(2);
-      nGlobDomain[0] = this->ni_glo;
-      nGlobDomain[1] = this->nj_glo;
-
-      // to be changed in future, need to rewrite more simply domain distribution
-      CServerDistributionDescription serverDescription(nGlobDomain, nbServer);
-      int distributedPosition ;
-      if (isUnstructed_) distributedPosition = 0 ;
-      else distributedPosition = 1 ;
-      
-      std::vector<std::vector<int> > serverIndexBegin = serverDescription.getServerIndexBegin();
-      std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
-      vector<unordered_map<size_t,vector<int>>> indexServerOnElement ;
-      CArray<int,1> axisDomainOrder(1) ; axisDomainOrder(0)=2 ;
-      auto zeroIndex=serverDescription.computeServerGlobalByElement(indexServerOnElement, context->getIntraCommRank(), context->getIntraCommSize(),
-                                                                  axisDomainOrder,distributedPosition) ;
-      // distribution is very bad => to redo
-      // convert indexServerOnElement => map<int,CArray<size_t,1>> - need to be changed later
-      map<int, vector<size_t>> vectGlobalIndex ;
-      for(auto& indexRanks : indexServerOnElement[0])
-      {
-        size_t index=indexRanks.first ;
-        auto& ranks=indexRanks.second ;
-        for(int rank : ranks) vectGlobalIndex[rank].push_back(index) ;
-      }
-      for(auto& vect : vectGlobalIndex ) globalIndex.emplace(vect.first, CArray<size_t,1>(vect.second.data(), shape(vect.second.size()),duplicateData)) ;
-    // some servers receves no index (zeroIndex array) => root process take them into account.
-      if (context->getIntraCommRank()==0) 
-        for(auto& rank : zeroIndex) globalIndex[rank] = CArray<size_t,1>() ; 
-    }
-*/    
+
     if (distType==EDistributionType::BANDS && isUnstructed_) distType=EDistributionType::COLUMNS ;
 
@@ -2134,6 +2134,4 @@
   CATCH
 
- 
-
   void CDomain::distributeToServer(CContextClient* client, bool inOut, map<int, CArray<size_t,1>>& globalIndexOut, std::map<int, CArray<size_t,1>>& globalIndexIn,
                                    shared_ptr<CScattererConnector> &scattererConnector, const string& domainId)
@@ -2409,6 +2407,6 @@
       CArray<double,1> value ;
       gathererConnector_->transfer(event, value, 0.); 
-      area.resize(ni,nj) ;
-      if (area.numElements()>0) area=CArray<double,2>(value.dataFirst(),shape(ni,nj),neverDeleteData) ; 
+      area_2d.resize(ni,nj) ;
+      if (area_2d.numElements()>0) area_2d=CArray<double,2>(value.dataFirst(),shape(ni,nj),neverDeleteData) ; 
     }
   }
@@ -2491,4 +2489,5 @@
     m["reorder_domain"] = TRANS_REORDER_DOMAIN;
     m["extract_domain"] = TRANS_EXTRACT_DOMAIN;
+    m["redistribute_domain"] = TRANS_REDISTRIBUTE_DOMAIN;
     return true;
   }
Index: XIOS3/trunk/src/node/domain.hpp
===================================================================
--- XIOS3/trunk/src/node/domain.hpp	(revision 2498)
+++ XIOS3/trunk/src/node/domain.hpp	(revision 2507)
@@ -214,4 +214,8 @@
          CArray<double, 2> bounds_lonvalue, bounds_latvalue;
          CArray<double, 1> areavalue;
+         int niValue_ ;
+         int njValue_ ;
+         int ibeginValue_ ;
+         int jbeginValue_ ;
 
 
@@ -241,4 +245,5 @@
          void checkArea(void);
          void checkLonLat();
+         void compute2dBox(void) ;
          
        public:
Index: XIOS3/trunk/src/node/field.cpp
===================================================================
--- XIOS3/trunk/src/node/field.cpp	(revision 2498)
+++ XIOS3/trunk/src/node/field.cpp	(revision 2507)
@@ -20,5 +20,7 @@
 #include "temporal_filter.hpp"
 #include "server_from_client_source_filter.hpp"
+#include "client_online_reader_filter.hpp"
 #include "file_reader_source_filter.hpp"
+#include "grid_redistribute_filter.hpp"
 #include "tracer.hpp"
 #include "graph_package.hpp"
@@ -205,5 +207,7 @@
   TRY
   {
-    return clientFromServerSourceFilter_->sendReadDataRequest(tsDataRequested) ;
+    if (clientFromServerSourceFilter_) return clientFromServerSourceFilter_->sendReadDataRequest(tsDataRequested) ;
+    else if (clientOnlineReaderFilter_) return clientOnlineReaderFilter_->sendReadDataRequest(tsDataRequested) ;
+    else ERROR("bool CField::sendReadDataRequest(const CDate& tsDataRequested)", << "uninitialized source filter");
   }
   CATCH_DUMP_ATTR
@@ -217,5 +221,7 @@
   TRY
   {
-    return clientFromServerSourceFilter_->sendReadDataRequestIfNeeded() ;
+    if (clientFromServerSourceFilter_) return clientFromServerSourceFilter_->sendReadDataRequestIfNeeded() ;
+    else if (clientOnlineReaderFilter_) return clientOnlineReaderFilter_->sendReadDataRequestIfNeeded() ;
+    else ERROR("bool CField::sendReadDataRequestIfNeeded(void)", << "uninitialized source filter");
   }
   CATCH_DUMP_ATTR
@@ -304,5 +310,7 @@
   TRY
   {
-    clientFromServerSourceFilter_->checkForLateData() ;
+    if (clientFromServerSourceFilter_) return clientFromServerSourceFilter_->checkForLateData() ;
+    else if (clientOnlineReaderFilter_) return clientOnlineReaderFilter_->checkForLateData() ;
+    else ERROR("void CField::checkForLateDataFromServer(void)", << "uninitialized source filter");
   }
   CATCH_DUMP_ATTR 
@@ -315,5 +323,6 @@
     {
       checkForLateDataFromServer() ;
-      clientFromServerSourceFilter_->trigger(CContext::getCurrent()->getCalendar()->getCurrentDate()) ;
+      if (clientFromServerSourceFilter_) clientFromServerSourceFilter_->trigger(CContext::getCurrent()->getCalendar()->getCurrentDate()) ;
+      else if (clientOnlineReaderFilter_) clientOnlineReaderFilter_->trigger(CContext::getCurrent()->getCalendar()->getCurrentDate()) ;
     } 
     else if (hasCouplerIn())
@@ -325,20 +334,5 @@
   CATCH_DUMP_ATTR
 
-
-  void CField::checkIfMustAutoTrigger(void)
-  TRY
-  {
-    mustAutoTrigger = clientFromServerSourceFilter_ ? clientFromServerSourceFilter_->mustAutoTrigger() : false;
-  }
-  CATCH_DUMP_ATTR
-
-  void CField::autoTriggerIfNeeded(void)
-  TRY
-  {
-    if (mustAutoTrigger)
-      clientFromServerSourceFilter_->trigger(CContext::getCurrent()->getCalendar()->getCurrentDate());
-  }
-  CATCH_DUMP_ATTR
-
+  
 
   //----------------------------------------------------------------
@@ -506,7 +500,7 @@
                                               bool bufferForWriting)
   {
-    auto& contextBufferSize = bufferSize[client] ;
-    auto& contextMaxEventSize = maxEventSize[client] ;
-    const std::map<int, size_t> mapSize = grid_->getDataBufferSize(client, getId(), bufferForWriting);
+    auto& contextBufferSize = bufferSize[client_] ;
+    auto& contextMaxEventSize = maxEventSize[client_] ;
+    const std::map<int, size_t> mapSize = grid_->getDataBufferSize(client_, getId(), bufferForWriting);
     for(auto& it : mapSize )
     {
@@ -525,7 +519,7 @@
                                                    bool bufferForWriting)
   {
-    auto& contextBufferSize = bufferSize[client] ;
-    auto& contextMaxEventSize = maxEventSize[client] ;
-    const std::map<int, size_t> mapSize = grid_->getAttributesBufferSize(client, bufferForWriting);
+    auto& contextBufferSize = bufferSize[client_] ;
+    auto& contextMaxEventSize = maxEventSize[client_] ;
+    const std::map<int, size_t> mapSize = grid_->getAttributesBufferSize(client_, bufferForWriting);
     for(auto& it : mapSize )
     {
@@ -797,5 +791,5 @@
   {
     // insert temporal filter before sending to files
-    clientToServerStoreFilter_ = std::shared_ptr<CClientToServerStoreFilter>(new CClientToServerStoreFilter(gc, this, client));
+    clientToServerStoreFilter_ = std::shared_ptr<CClientToServerStoreFilter>(new CClientToServerStoreFilter(gc, this, client_));
     // insert temporal filter before sending to files
     getTemporalDataFilter(gc, fileOut_->output_freq)->connectOutput(clientToServerStoreFilter_, 0);
@@ -809,8 +803,54 @@
   } 
 
+/*
+  void CField::connectToOnlineWriter(CGarbageCollector& gc)
+  {
+    // insert temporal filter before sending to files
+    CField* fieldOut ;
+    redistributeFilter_ = std::shared_ptr<CGridRedistributeFilter>(new CGridRedistributeFilter(gc, this, fieldOut));
+    fieldOut->setFileOut(this->getFileOut());
+    fileOut_->replaceEnabledFields(this, fieldOut) ;
+    // insert temporal filter before sending to files
+    getTemporalDataFilter(gc, fileOut_->output_freq)->connectOutput(redistributeFilter_, 0);
+    fieldOut->inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc)); 
+    fieldOut->instantDataFilter = fieldOut->inputFilter ;
+    redistributeFilter_->connectOutput(fieldOut->inputFilter, 0);
+    fieldOut->connectToFileWriter(gc) ;
+    fieldOut->solveServerOperation() ; // might not be called, create a new time functor.... find a better solution later
+    const bool buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
+  
+    if(buildGraph_) 
+    {
+      clientToServerStoreFilter_->graphPackage = new CGraphPackage;
+      clientToServerStoreFilter_->graphEnabled = true;
+      clientToServerStoreFilter_->graphPackage->inFields.push_back(this);
+    }
+  } 
+*/
+  void CField::connectToOnlineWriter(CGarbageCollector& gc)
+  {
+    // insert temporal filter before sending to files
+    clientOnlineWriterFilter_ = std::shared_ptr<CClientOnlineWriterFilter>(new CClientOnlineWriterFilter(gc,this)) ;
+    getTemporalDataFilter(gc, fileOut_->output_freq)->connectOutput(clientOnlineReaderFilter_, 0);
+   
+    const bool buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
+  
+    if(buildGraph_) 
+    {
+      // to do
+    }
+  } 
+
+  void CField::connectToOnlineReader(CGarbageCollector& gc)
+  {
+    // insert temporal filter before sending to files
+    clientOnlineReaderFilter_ = std::shared_ptr<CClientOnlineReaderFilter>(new CClientOnlineReaderFilter(gc,this)) ;
+    clientOnlineReaderFilter_ -> connectOutput(inputFilter,0) ;
+  } 
+
   void CField::connectToCouplerOut(CGarbageCollector& gc)
   {
     // insert temporal filter before sending to files
-    clientToServerStoreFilter_ = std::shared_ptr<CClientToServerStoreFilter>(new CClientToServerStoreFilter(gc, this, client));
+    clientToServerStoreFilter_ = std::shared_ptr<CClientToServerStoreFilter>(new CClientToServerStoreFilter(gc, this, client_));
     instantDataFilter->connectOutput(clientToServerStoreFilter_, 0);
     const bool buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
@@ -951,5 +991,5 @@
   void CField::connectToServerToClient(CGarbageCollector& gc)
   {
-    serverToClientStoreFilter_ = std::shared_ptr<CServerToClientStoreFilter>(new CServerToClientStoreFilter(gc, this, client));
+    serverToClientStoreFilter_ = std::shared_ptr<CServerToClientStoreFilter>(new CServerToClientStoreFilter(gc, this, client_));
     instantDataFilter->connectOutput(serverToClientStoreFilter_, 0);
     const bool buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
@@ -1435,5 +1475,5 @@
   {
     CContext* context = CContext::getCurrent();
-    client = contextClient;
+    client_ = contextClient;
   
     // A grid is sent by a client (both for read or write) or by primary server (write only)
@@ -1441,11 +1481,12 @@
     {
       if (getRelFile()->mode.isEmpty() || (!getRelFile()->mode.isEmpty() && getRelFile()->mode == CFile::mode_attr::write))
-        grid_->setContextClient(contextClient);
+        /*grid_->setContextClient(contextClient) */; // => nothing to do with thats now, to remove...
     }
     else if (context->getServiceType()==CServicesManager::CLIENT)
     {
       if (grid_)
-        grid_->setContextClient(contextClient);
+        /*grid_->setContextClient(contextClient)*/; // => nothing to do with thats now, to remove...
       else
+
         ERROR( "CField::setContextClient(contextClient)",
                << "Grid not defined for " << getId()
@@ -1459,24 +1500,24 @@
   void CField::sendFieldToFileServer(void)
   {
-    CContext::getCurrent()->sendContextToFileServer(client);
-    getRelFile()->sendFileToFileServer(client);
+    CContext::getCurrent()->sendContextToFileServer(client_);
+    getRelFile()->sendFileToFileServer(client_);
     sentGrid_ = grid_-> duplicateSentGrid() ;
-    sentGrid_->sendGridToFileServer(client, false);
+    sentGrid_->sendGridToFileServer(client_, false);
     name = getFieldOutputName() ;
-    this->sendAllAttributesToServer(client);
-    this->sendAddAllVariables(client);
+    this->sendAllAttributesToServer(client_);
+    this->sendAddAllVariables(client_);
   }
 
   void CField::sendFieldToInputFileServer(void)
   {
-    CContext::getCurrent()->sendContextToFileServer(client);
-    getRelFile()->sendFileToFileServer(client);
+    CContext::getCurrent()->sendContextToFileServer(client_);
+    getRelFile()->sendFileToFileServer(client_);
     sentGrid_ = grid_-> duplicateSentGrid() ;
-    sentGrid_->sendGridToFileServer(client, true);
+    sentGrid_->sendGridToFileServer(client_, true);
     read_access=true ; // not the best solution, but on server side, the field must be a starting point of the workflow
                        // must be replace by a better solution when implementing filters for reading and send to client
                        // on server side
-    this->sendAllAttributesToServer(client);
-    this->sendAddAllVariables(client);
+    this->sendAllAttributesToServer(client_);
+    this->sendAddAllVariables(client_);
   }
 
@@ -1486,5 +1527,5 @@
     else sendFieldToCouplerOut_done_=true ;
     sentGrid_ = grid_-> duplicateSentGrid() ;
-    sentGrid_->sendGridToCouplerOut(client, this->getId());
+    sentGrid_->sendGridToCouplerOut(client_, this->getId());
     this->sendGridCompleted();
 
@@ -1502,12 +1543,12 @@
       CEventClient event(getType(),EVENT_ID_GRID_COMPLETED);
 
-      if (client->isServerLeader())
+      if (client_->isServerLeader())
       {
         CMessage msg;
         msg<<this->getId();
-        for (auto& rank : client->getRanksServerLeader()) event.push(rank,1,msg);
-        client->sendEvent(event);
-      }
-      else client->sendEvent(event);
+        for (auto& rank : client_->getRanksServerLeader()) event.push(rank,1,msg);
+        client_->sendEvent(event);
+      }
+      else client_->sendEvent(event);
    }
    CATCH_DUMP_ATTR
Index: XIOS3/trunk/src/node/field.hpp
===================================================================
--- XIOS3/trunk/src/node/field.hpp	(revision 2498)
+++ XIOS3/trunk/src/node/field.hpp	(revision 2507)
@@ -28,4 +28,6 @@
 #include "client_to_server_store_filter.hpp"
 #include "file_reader_source_filter.hpp"
+#include "client_online_reader_filter.hpp"
+#include "client_online_writer_filter.hpp"
 
 
@@ -56,4 +58,5 @@
    class CSourceFilter;
    class CServerToClientFilter;
+   class CGridRedistributeFilter;
    ///--------------------------------------------------------------
 
@@ -199,6 +202,4 @@
         void checkForLateDataFromCoupler(void) ;
 
-        void checkIfMustAutoTrigger(void); // ym obsolete
-        void autoTriggerIfNeeded(void); //ym obsolete
         void triggerLateField(void) ;
 
@@ -237,4 +238,6 @@
         void connectToFileReader(CGarbageCollector& gc) ;
         void connectToServerToClient(CGarbageCollector& gc) ;
+        void connectToOnlineWriter(CGarbageCollector& gc) ;
+        void connectToOnlineReader(CGarbageCollector& gc) ;
 
         void setContextClientDataBufferSize(map<CContextClient*,map<int,size_t>>& bufferSize, 
@@ -267,4 +270,5 @@
          CGrid*  grid_=nullptr;
          CGrid* getGrid(void) { return grid_; } 
+         void setGrid(CGrid* grid) { grid_=grid; } 
       
       private:
@@ -327,8 +331,8 @@
         
       private:
-         CContextClient* client;
+         CContextClient* client_;
       public:
          void setContextClient(CContextClient* newContextClient);
-         CContextClient* getContextClient(void) {return client;}
+         CContextClient* getContextClient(void) {return client_;}
 
       private:
@@ -372,6 +376,4 @@
          std::shared_ptr<COutputPin> selfReferenceFilter; // probably redondant with inputFilter
 
-         //! The source filter for data provided by the client
-//         std::shared_ptr<CSourceFilter> clientSourceFilter; // obsolete to remove
  
          //! The source filter for data provided by the model to enter the client workflow
@@ -393,7 +395,4 @@
          std::shared_ptr<CFileReaderSourceFilter> fileReaderSourceFilter_;
 
-         //! The source filter for data provided by the server
-//         std::shared_ptr<CSourceFilter> serverSourceFilter; // obsolete to remove
-        
          //! The terminal filter which send data to server for writing
          std::shared_ptr<CClientToServerStoreFilter> clientToServerStoreFilter_;
@@ -405,4 +404,13 @@
          std::shared_ptr<CServerToClientStoreFilter> serverToClientStoreFilter_;
 
+         //! the filter to redistribute data before to call the fileWriterStoreFilter ==> to remove
+         std::shared_ptr<CGridRedistributeFilter>  redistributeFilter_ ;
+
+          //! the filter to connect to online reader
+         std::shared_ptr<CClientOnlineReaderFilter>  clientOnlineReaderFilter_ ;
+
+          //! the filter to connect to online writer
+         std::shared_ptr<CClientOnlineWriterFilter>  clientOnlineWriterFilter_ ;
+
 
    }; // class CField
